# Secureworks Microsoft Defender for Endpoint Integration Azure Infrastructure

This set of terraform templates will help your organization to re-populate
the Azure Acrtive Directoy Application that Secureworks uses to interact
with Microsoft Azure.

# Clean Up Lingering Azure AD Applications

1. In Azure portal, go to `Azure Active Directory`. Click on `App registrations` 
   on the left hand side pane under the `Manage` group.
2. Click on `All applications` on the right hand side pane and type
   `SCWX-TDR-MDATP-APP` in the search box showing `Start typing a name or Applicatgion ID to filter these results`.
   If you see one or more application/client listed in the result set, click on one of those applications. Otherwise, skip
   to next paragraph.
3. Now in the application, click on `Delete`. A `Delete app registration` pane
   pops up. Check the checkbox `I understand the implications of deleting this app registration.`, 
   then click on `Delete` to proceed to delete the Azure AD application.
4. If you see more than one application in step 2, repeat step 3 for all of
   them.

# Re-Create Azure AD Application

1. In Azure cloud bash shell (or any other preferred \*nix shell environment
   with azure-cli and terraform available), copy over all the files and place
   in a folder. This must be a different folder than the one used for the 
   Secureworks Taegis XDR Terraform templates that also created the Event Hub.
2. If not using Azure cloud shell, log into Azure using azure cli: `az login`.
   Or, if desired, log into Azure as an Azure service principal
   `az login --service-principal -u <service_principal_name> -p "<service_principal_password>" --tenant "<service_principal_tenant_id>"`
   Replacing <service_principal_name>, <service_principal_password> and
   <service_principal_tenant_id> with your organization's sepecific values.
   Using a service principal requires that service principal has appropriate
   permissions.
3. Go into the folder in step 1. Update the terraform.tfvars file with your
   organization's Azure tenant_id.
4. Still in the same folder in step 1, run `terraform init`. This will set up
   the terraform environment.
5. Run
   `terraform plan -out ScwxIntegration.tfplan -var-file="terraform.tfvars"`.
   This will generate the terraform execution plan that shows resources that
   will be created/updated. This will also write it to the file
   ScwxIntegration.tfplan in current folder.
   If resources the terraform executation plan look correct, run
   `terraform apply ScwxIntegration.tfplan` to actually deploy the resources to
   Azure.
6. If terraform times out when running step 5, repeat steps 4 and 5 so that
   terraform will deploy those resources failed to deploy in the previous run.
7. After the completion of `terraform apply` step, Terraform prints out the
   following entries as outputs:
     - application_id
     - application_secret
     - azure_consent_url
8. You can run `terraform output` to show the above outputs again.
9. Please follow the url "azure_consent_url", this will consent the newly
   created Azure application's different permission requirements.
   NOTE: the application_secret will be valid only after the application has
   been consented. 
10. Use the application_id and application_secret values to configure your 
    Defender integration in Taegis portal.

References:
https://docs.microsoft.com/en-us/azure/developer/terraform/get-started-cloud-shell#authenticate-to-azure
